mod Ex09a

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end piatok 24.4.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para výroková logika, 
   \item \para výrokovo-logické vyplývanie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 3 
  \end
  \para Odovzdať do 29.4.2020 (streda) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Ján Komara. Specification and Verification of 
         Programs. Online. 
  \end

rem 
  \para \bf  Chapter. Propositional Logic.  \end 

rem 
  \para \bf  Section. Language.  \end 

rem 
  \para \bf  Formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para Atomic formulas: \ft R \end, \ft Q \end. 
   \item \para Propositional connectives: \ft \t \end, \ft \f \end, \ft ~R \end. 
         \ft R & Q \end, \ft R \/ Q \end, \ft R -> Q \end, \ft R <-> Q \end. 
  \end

rem 
  \para \bf  Section. The Method of Propositional Tableaux.  \end 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicp  \end in the file \it  
  mlogicp.cl  \end contains the syntax of propositional tableau rules. 

theory Exercises logic: 'prop_neq_min'

pred/0 A 
  A

pred/0 B 
  B

pred/0 C 
  C

rem 
  \para \bf  Exercise. (1 bonus point)  \end Prove that logical disjunction is 
  distributive over logical conjunction: 
  \eq* 
    A \/ B & C -> (A \/ B) & (A \/ C)
  \end

thm Distributivity
  A \/ B & C -> (A \/ B) & (A \/ C)

rem 
  \para \bf  Exercise. (1 bonus point)  \end Prove that logical implication is 
  transitive: 
  \eq* 
    (A -> B) & (B -> C) & A -> C
  \end

thm Transitivity
  (A -> B) & (B -> C) & A -> C

rem 
  \para \bf  Exercise. (1 bonus point)  \end Prove that contrapositives of 
  logical implication are logically equivalent: 
  \eq* 
    (A -> B) <-> ~B -> ~A
  \end

thm Contraposition
  (A -> B) <-> ~B -> ~A

end theory Exercises

rem 
  \para \bf  [CL] Propositional logic with automatic rules.  \end 

theory Exercises2 logic: 'prop_def'

pred/0 A 
  A

pred/0 B 
  B

pred/0 C 
  C

rem 
  \para \bf  Exercise.  \end Prove that logical disjunction is distributive over 
  logical conjunction: 
  \eq* 
    A \/ B & C -> (A \/ B) & (A \/ C)
  \end

thm Distributivity
  A \/ B & C -> (A \/ B) & (A \/ C)

rem 
  \para \bf  Exercise.  \end Prove that logical implication is transitive: 
  \eq* 
    (A -> B) & (B -> C) & A -> C
  \end

thm Transitivity
  (A -> B) & (B -> C) & A -> C
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove that contrapositives of logical implication 
  are logically equivalent: 
  \eq* 
    (A -> B) <-> ~B -> ~A
  \end

thm Contraposition
  (A -> B) <-> ~B -> ~A

end theory Exercises2

