mod Ex09b

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end piatok 24.4.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para výroková logika, 
   \item \para výrokovo-logické vyplývanie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 3 
  \end
  \para Odovzdať do 29.4.2020 (streda) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Ján Komara. Specification and Verification of 
         Programs. Online. 
  \end

rem 
  \para \bf  Chapter. Propositional Logic.  \end 

rem 
  \para \bf  Section. Tableaux with Axioms.  \end 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicpx  \end in the file \it  
  mlogicpx.cl  \end contains the syntax of tableau rules for propositional 
  tableaux with axioms. The module \it  Mlogicd  \end in the file \it  
  mlogicd.cl  \end contains the syntax of derived tableau rules. 

rem 
  \para \bf  Remark.  \end The following logical problems are from the cases 
  solved by the famous inspector G. Lestrade of Scotland Yard. 

theory Lestrade1 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

rem 
  \para \bf  Exercise.  \end Investigation by Inspector Lestrade brought up the 
  following facts: 
  \items 
   \item \para \it  (1)  \end The robbery was done by at least by \ft X \end, 
         \ft Y \end, or \ft Z \end. 
   \item \para \it  (2)  \end \ft X \end always works with a companion. 
   \item \para \it  (3)  \end \ft Z \end is not guilty. 
  \end
  \para Problem: Is \ft Y \end guilty? 
  \para \it  Formalization.  \end 
  \items 
   \item \para The constants \ft X \end, \ft Y \end a \ft Z \end represent the 
         suspects. 
   \item \para The predicate \ft G(x) \end holds if \ft x \end is guilty. 
  \end
  \para The axioms \it  A1  \end, \it  A2  \end a \it  A3  \end arithmetize the 
  facts \it  (1)  \end, \it  (2)  \end a \it  (3)  \end. Our goal is to prove 
  that the claim \ft G(Y) \end is a tautological consequence of these axioms. 

axiom A1
  G(X) \/ G(Y) \/ G(Z)

axiom A2
  G(X) -> G(Y) \/ G(Z)

axiom A3
  ~G(Z)

lemma Consistency
  \f
proof 
 use A1
  use A2
   use A3
    cut G(X)
     conj
     conj.....

thm Gy
  G(Y)

end theory Lestrade1

theory Lestrade2 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

loc rem 
  \para \bf  Exercise. (1 bonus point)  \end What are the consequences of the 
  following facts? 
  \items 
   \item \para \it  (1)  \end If \ft X \end is guilty and \ft Y \end is not then 
         \ft Z \end is guilty. 
   \item \para \it  (2)  \end \ft Z \end never works alone. 
   \item \para \it  (3)  \end \ft X \end never works with \ft Z \end. 
   \item \para \it  (4)  \end Except \ft X \end, \ft Y \end, or \ft Z \end 
         nobody else is involved in the case. 
  \end
  \para Decide the guiltiness of each person involved, i.e. prove whether G(x) 
  or \ft ~G(x) \end for every \ft x = X,Y,Z \end. 

axiom A1
  G(X) & ~G(Y) -> G(Z)

axiom A2
  G(Z) -> G(X) \/ G(Y)

axiom A3
  ~(G(X) & G(Z))

axiom A4
  G(X) \/ G(Y) \/ G(Z)

lemma Consistency
  \f

end theory Lestrade2

theory Lestrade3 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

rem 
  \para \bf  Exercise. (1 bonus point)  \end The merchant McGregor was robbed. 
  There were three suspects \ft X \end, \ft Y \end, and \ft Z \end. The 
  following facts were unearthed: 
  \items 
   \item \para \it  (1)  \end All suspects and nobody else was that day in 
         McGregor's store. 
   \item \para \it  (2)  \end If \ft X \end is guilty then he worked with a 
         companion. 
   \item \para \it  (3)  \end \ft Y \end is guilty if and only if \ft Z \end is 
         guilty. 
  \end
  \para Decide the guiltiness of each person involved. 

axiom A1
  G(X) \/ G(Y) \/ G(Z)

axiom A2
  G(X) -> G(Y) \/ G(Z)

axiom A3
  G(Y) <-> G(Z)

lemma Consistency
  \f

end theory Lestrade3

theory Lestrade4 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

fun/0 W 

pred G 

rem 
  \para \bf  Exercise. (1 bonus point)  \end In a police case the following was 
  found out: 
  \items 
   \item \para \it  (1)  \end If \ft X \end is guilty then \ft Y \end was his 
         companion. 
   \item \para \it  (2)  \end If \ft Y \end is guilty then either \ft X \end is 
         not or \ft Z \end is guilty. 
   \item \para \it  (3)  \end If \ft W \end is guilty then \ft X \end is and 
         \ft Z \end is not. 
   \item \para \it  (4)  \end If \ft X \end is not guilty then \ft W \end is. 
  \end
  \para Decide the guiltiness of each person involved. 

axiom A1
  G(X) -> G(Y)

axiom A2
  G(Y) -> G(Z) \/ ~G(X)

axiom A3
  G(W) -> G(X) & ~G(Z)

axiom A4
  ~G(X) -> G(W)

lemma Consistency
  \f

end theory Lestrade4

